/*************************************************************
* archdep.c Code that change depending on the microcontroller and implimentation
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
*
*
* Chiip (ATmega8L8) Flavor
* Copyright YOLD 3173 OpenWii all rights reversed.
*
*
* Extra credits go to krall for fixing ATMEGA support
* http://www.openwii.org/forums/viewtopic.php?t=47
*
**************************************************************/

/*Include common files*/
#include "../common/common.h"

/* do anything specefic to this micro */
inline void machInit() {
	//OC1A/OC1B disconnected
	TCCR1A = 0;
	//set timer mode to normal ( TCNT1 counts up to 0xFFFF )
	//prescaler=1
	TCCR1B = _BV(CS10);

	// STUFF ONLY NEEDED FOR LED TIMINGS
	//
	///*set timer to clear timer on compare match
	//prescaler=1*/
	//TCCR1B = _BV(WGM12) | _BV(CS10);
	///*value to compare against*/
	//OCR1A=MSTIMERDIV;
	
	DDRC|= LEDPIN;         /* enable PD5 as output */
	/*Enable Pullup Resistor on chip*/
	PORTD|=SW0PIN;
}

/* disables interrupts while reading from 16 bit register  */
/* commented out as i dont think this is necessary anymore since no timer*/

/*THIS SHOULDNT BE NECESSARY SINCE I AM NOT USING INTS ANYMORE*/
/*right! could have been unnecessary in the first place.. not sure. :-/ -krall
uint16_t read_timer1(void)
{
	uint8_t sreg;
	uint16_t val;
	sreg = SREG;
	cli();
	val = TCNT1;
	SREG = sreg;
	return val;
}
*/

/* wait approx 1 us */
inline void waitus(uint16_t us)
{
	int16_t t0=TCNT1;
	us*=(uint8_t)USTIMERDIV; //us now = how long 1 ms takes to pass (this requires mathlibs and more space...)
	while((TCNT1-t0) < us); //only works correctly if timer is not in compare mode -krall
}
