/*************************************************************
* main.c - openwii umod2, elegantly simple version
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
**************************************************************/

#include "common.h"

//void (*jump_to_loader)(void) = BOOTLADDR;
/*Prototype the main function as noreturn*/
int main(void) __attribute__ ((noreturn));

/*teh main!*/
int main()
{
	uint8_t region;
	uint16_t ret_word;	
	machInit();
	region=nvReadByte(EEREGADDR);
	if((region!=EEERASEDSTATE) || SW0IN ) { //if no switch or eeprom is ok
		//LEDON;		//turn led on
	} else {
		region=OFF_R;
		//LEDOFF;	//this may not be needed
	}
	Sync();
	/*Upload our mn10200 code to drive*/
	sendBlock(0x408000,(uint8_t *)&BINARYSTART,(uint16_t)&BINARYSIZE);
	SerialRequest(CMD_WRITE, REGXFERADDR,0x1,region,NULL);
	//LEDTOG;
	while(1) {
		SerialRequest(CMD_WRITE, UNLOCKADDR, 1, 0x41, NULL); //unlock debug mode
		/*Check to see if its time to jack in our code*/
		if(SerialRequest(CMD_READ, STACKRET, 2, 0x0, &ret_word)==0) {
			if(ret_word == ORGRET) {
				/*If so then replace the return address from discLogin with our return address*/
				SerialRequest(CMD_WRITE, STACKRET, 2, 0x8000, NULL);
				SerialRequest(CMD_WRITE, STACKRET+2, 1, 0x40, NULL);
				//LEDTOG;
			}
		} else {
			Resync();
		}
		/*Check to see if the user has changed the drive's region code*/
		SerialRequest(CMD_READ, REGXFERADDR, 2, 0x0, &ret_word);
		if((ret_word>>8) == 0xa5) {
		        if((ret_word&0xff) != region) {
		                region=ret_word & 0xff;
		                nvWriteByte(EEREGADDR,region); // store the new region
		                //LEDTOG;
		        }
		}
		/*Check to see if the user want to upgrade the firmware*/
		SerialRequest(CMD_READ, CMD_UPDT_ADDR, 2, 0x0, &ret_word);
		if(ret_word == CMD_LOAD) 
		{
			LEDTOG;
			LEDON;
#ifdef DEBUG
			SerialRequest(CMD_WRITE, DEBUG_ADDR, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+2, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+4, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+6, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+8, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+10, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+12, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+14, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+16, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+18, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+20, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+22, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+24, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+26, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+28, 2, 0x0000, NULL);
			SerialRequest(CMD_WRITE, DEBUG_ADDR+30, 2, 0x0000, NULL);
#endif
			//loader(); // call the loader
			
			asm volatile("push r16\n\t"
				     "ldi r16,%0\n\t"
			    	     "mov r31,r16\n\t"
				     "ldi r16,%1\n\t"
			     	     "mov r30,r16\n\t"
			     	     "pop r16\n\t"
		     		     "ijmp\n\t"
		     		     ::"M" (BOOTLH) , "M" (BOOTLL));
				
	
	}
	}	
}
