/*************************************************************
* serial.h - openwii serial header
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
**************************************************************/
#ifndef SERIAL_H_
#define SERIAL_H_

#define CMD_READ 0xFF
#define CMD_WRITE 0xFE

/*How many uS to wait between clocking out/in data*/
#define SERCLKDLY 0x8

/*For drive ID 0x40bca7*/
#define D2ACHK 0x2605 /*d2a/dms drive id*/
#define D2BCHK 0x0709 /*d2b drive id*/
#define SERIAL_CMD_SIZE 10

uint8_t Sync();
void Resync();
uint8_t SerialRequest(uint8_t command, uint32_t offset, uint8_t size, uint16_t data, uint16_t *ret);
void serialWriteByte(uint32_t offset, uint8_t data);
void serialWriteWord(uint32_t offset, uint16_t data);
void sendBlock(uint32_t offset, uint8_t *buff, uint16_t size);
#endif /*SERIAL_H_*/
