/*************************************************************
* archdep.c Code that change depending on the microcontroller and implimentation
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* msp430 flavor
* Copyright YOLD 3173 OpenWii all rights reversed.
**************************************************************/

/*Include common files*/
#include "../common/common.h"

static int make_gdb_happy = 1;

/*micro dependant misc startup stuff*/
inline void machInit() {
	// Calibrate DCO to 16MHz
	BCSCTL1 = CALBC1_16MHZ;
	DCOCTL = CALDCO_16MHZ;
	BCSCTL2 = DIVS_DIV8;                   // SMCLK = DCOCLK/8 = 2MHz
	WDTCTL = WDTPW + WDTHOLD;       // Stop watchdog timer
	// Initialize pins to inputs (high impedance)
	P1DIR &= ~PIN_IN;
	P1OUT &= ~(PIN_CLK | PIN_OUT);
	P1DIR |= (PIN_CLK | PIN_OUT);
	TACTL = TACLR;
	TACTL = TASSEL_SMCLK | ID_DIV2 | MC_2;
	CCR0 = TAR + 1000;		// Generate TimerA Interrupt in 1ms
	P1DIR |= 0x01;			// LED P1.0 Output
	P1OUT |=SW0PIN;			//make switch pin pullup to high
	P1REN |=SW0PIN;			//enable pullup
}	

/* wait approx 1 us */
inline void waitus(uint16_t us)
{
	uint16_t t0 = TAR;
	while( (TAR-t0) < us);
}

/*read a byte from non-vol memory (eeprom, flash, whatever)*/
inline uint8_t nvReadByte(uint16_t addr) {
}
/*write a byte to non-vol memory*/
inline void nvWriteByte(uint16_t addr,uint8_t byte){
}
