/*************************************************************
* archdep.h Things that change depending on the archetecture
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* The MPS430 version
**************************************************************/

/*Other files to include for this micro*/
#ifndef ARCHDEP
#define ARCHDEP
#include <signal.h>
#include "msp430x20x3.h"

#define ARCH_MSP430

/*This is a type definition for program memory. Most microcontrollers use a special type of pointer for progmem compared to datamem*/
#define PGM_P uint8_t *

#define PIN_CLK 0x20
#define PIN_OUT 0x40
#define PIN_IN 0x80

/*macros to change the output pin states*/
#define OUTHIZ P1DIR &= ~PIN_OUT // Output HiZi
#define OUTLOW P1DIR |= PIN_OUT	// Output Low
#define CLKHIZ P1DIR &= ~PIN_CLK // clock HiZ
#define CLKLOW P1DIR |= PIN_CLK //Drive clock low

/*Macro to read input pin as 0 or 1*/
#define GETIN (((P1IN & PIN_IN) >> 7) & 0x1) // read input

/*Macros for LED*/
#define LEDOFF	P1OUT &= ~0x1	//Turn led on
#define LEDON	P1OUT |= 0x1	//turn led off
#define LEDTOG	P1OUT ^= 0x1	//Toggle led

/*Macros to define switch input*/
#define SW0PIN 0x08
#define SW0IN ((P1IN >> 3) & 0x1)

#define pgmReadWord(a) (*a)

#endif
