;
; Openwii 2.0 PIC 12F629/675 sourcecode by Fuzzylogic
; Copyright (C) 2006 (April, 4th) Fuzzylogic/OpenWii (admin@openwii.org)
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; Has all the Openwii specs:
; Working on D2A/D2B/DMS Wii consoles
; Dvd+r/dvd+rw/dvd-rw support
; Proper Speed fix
;

    processor 12F675
    #include <P12F675.INC>
    __config 0x1184
;   _CPD_OFF & _CP_OFF & _BODEN_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF 
;   & _INTRC_OSC_NOCLKOUT 


CLOCK 	equ 0
P_OUT	equ 1
P_IN	equ 2

; DMS/D2A fixed values
UNLOCK_ADRL 	equ 0xB6
ORGRET_L	equ 0xC7
ORGRET_H	equ 0xD4

REGION		equ 0x02		; EU PAL



	CBLOCK  0x20			    ;Store variables starting at 0x20

	CMD_0_CMD
	CMD_2_OFSHI
	CMD_3_OFSLO
	CMD_4_B1 
	CMD_5_OFSHIGH
	CMD_6_B2 
	CMD_8_S1 
	IN_L		
	IN_H 		
	TEMP1 		
	TEMP2 		
	TMP		
	OFFSET_LO
	OFFSET_HI

	endc


; Program

	Org 0x000


;
;------- Main program starts here ------------------
;  Initialize variables and set output pins
;
INIT
    	BSF STATUS,RP0  	     	; Register-Bank(0/1)-Select
    	CLRF ANSEL           		; Clear ANSEL
;    	CALL 0x3FF 			; Retrieve Factory Calibration Value
;   	MOVWF OSCCAL         		; update register with factory cal value 

    	MOVLW 0x04
    	MOVWF TRISIO			; TRISIO / Set in/ouput pins

    	BCF STATUS,RP0       		; Register-Bank(0/1)-Select
    	MOVLW 07h 			; Set GP<2:0> to
	MOVWF CMCON 			; digital IO
	CLRF GPIO

    	GOTO MAIN_LOOP

;	
; Read Byte
;
READ_BYTE
	CLRF TEMP1			; temp byte =0
	movlw 8
	movwf TEMP2			; counter

READ_LOOP
	RRF TEMP1,F

	BSF GPIO,CLOCK			; Set clock High
	GOTO $+1

	BCF GPIO,CLOCK			; Set clock Low
	GOTO $+1

	BSF TEMP1,7
	BTFSS GPIO,P_IN    		; Read input pin
	BCF TEMP1,7			; store bit in TEMP1

    	BSF GPIO,CLOCK			; Set clock High
	GOTO $+1

	DECFSZ TEMP2,F			; all 8 bit's read?
	GOTO READ_LOOP			; no, continue
JUSTWAIT
    	MOVLW 0x14			; delay 100 us 
JUSTWAIT_X
    	MOVWF TEMP2
RL_JW
	GOTO $+1			; 2
	DECFSZ TEMP2,F			; 1/2
	GOTO RL_JW			; 2
    	MOVF TEMP1,W
    	RETURN
;
;
SYNC_QUEUE
    	CLRF TEMP1			; buffer
    	CLRF TEMP2

SYNC_QUEUE_INIT
    	MOVLW 0xEE
    	SUBWF TEMP2,W			; check buffer_hi=EE?
    	BTFSS STATUS,Z
    	GOTO SYNC_CHECK_BL		; no, keep looking
    	MOVLW 0xEE
    	SUBWF TEMP1,W			; buffer_lo=EE? 

SYNC_CHECK_BL
	BTFSC STATUS,Z
	RETURN				; buffer = eeee, exit
	BCF STATUS,C			; clear carry
	RRF TEMP2,F			; shift buffer > 1 
	RRF TEMP1,F

	BSF GPIO,CLOCK			; Set clock High
	GOTO $+1

	BCF GPIO,CLOCK			; Set clock Low
	GOTO $+1

	BSF TEMP2,7
	BTFSS GPIO,P_IN    		; Read input pin
	BCF TEMP2,7

    	BSF GPIO,CLOCK			; Set clock High
	GOTO $+1

	GOTO SYNC_QUEUE_INIT


;
; Write Byte	, byte to TX in W
;
WRITE_BYTE_00
	CLRW
WRITE_BYTE
    	MOVWF TEMP1			; byte to tx
	movlw 8   	 
	movwf TEMP2			; counter

WRITE_LOOP
	BSF GPIO,CLOCK			; Set Clock High
	GOTO $+1

    	BTFSC TEMP1,0
    	BSF GPIO,P_OUT			; Set P_OUT High
    	BTFSS TEMP1,0	
    	BCF GPIO,P_OUT			; Set P_OUT Low
	GOTO $+1

    	BCF GPIO,CLOCK			; Set Clock Low
	GOTO $+1

    	BSF GPIO,CLOCK			; Set Clock High
	GOTO $+1

	RRF TEMP1,F
    	DECFSZ TEMP2,F
	GOTO WRITE_LOOP
    	GOTO JUSTWAIT
;
; load variables in CMD_0..CMD_8
;
WRITE_CMD	
	MOVWF CMD_0_CMD
WRITE_CMD_LOOP
	MOVF CMD_0_CMD,W		; CMD
	CALL WRITE_BYTE
	CALL WRITE_BYTE_00
	MOVF CMD_2_OFSHI,W		; OFFSET_HI
	CALL WRITE_BYTE
	MOVF CMD_3_OFSLO,W		; OFFSET_LO
	CALL WRITE_BYTE
	MOVF CMD_4_B1,W			; B1
	CALL WRITE_BYTE
	MOVF CMD_5_OFSHIGH,W		; OFFSET_HIGH
	CALL WRITE_BYTE
	MOVF CMD_6_B2,W			; B2
	CALL WRITE_BYTE
	CALL WRITE_BYTE_00
	MOVF CMD_8_S1,W			; S1
	CALL WRITE_BYTE
	CALL WRITE_BYTE_00

	movlw 0xC8			; 200x5=1000
	CALL JUSTWAIT_X			; wait 1000us

    	CALL READ_BYTE			; read byte
    	CALL READ_BYTE
    	MOVWF IN_H			; store IN_H (temp)
    	CALL READ_BYTE
    	MOVWF IN_L			; store IN_L

	BTFSS CMD_8_S1,1		; S1==0x02?
	GOTO WRITE_CMD_END
    	CALL READ_BYTE			; read high byte

WRITE_CMD_END
	MOVF IN_H,F			; IN_H = 00?
    	BTFSC STATUS,Z
	GOTO WRITE_RETURN

    	CALL SYNC_QUEUE			; else , sync queue
    	GOTO WRITE_CMD_LOOP

WRITE_RETURN
	MOVWF IN_H			; store high byte IN_H
	MOVF IN_L,W			; Return IN_L in W
	RETURN 				; exit

;
; Unlock drive
;
UNLOCK
    	MOVLW 0x41
    	MOVWF CMD_4_B1			; set b1=41
    	CLRF CMD_6_B2			; clear b2
    	CLRF CMD_5_OFSHIGH		; clear offset_high
    	MOVLW UNLOCK_ADRL		; 0x82b6
    	MOVWF CMD_3_OFSLO
    	MOVLW 0x82
    	MOVWF CMD_2_OFSHI
    	MOVLW 0x01
    	MOVWF CMD_8_S1			; S1
    	MOVLW 0xFE			; CMD
    	GOTO WRITE_CMD
;
; in: offsetHIGH, offset_hi/lo, B1
;
POKE_BYTE
	MOVWF CMD_5_OFSHIGH		; offset HIGH
;    	MOVF TMP,W		
;    	MOVWF CMD_4_B1			; B1
    	CLRF CMD_6_B2			; clear B2
    	MOVLW 0x01			
    	MOVWF CMD_8_S1			; S1 byte
    	MOVLW 0xFE			; CMD
    	GOTO WRITE_CMD
;
; in: offsetHIGH, offset_hi/lo
; return: IN_L in W
;
;PEEK_BYTE
;    	MOVWF CMD_5_OFSHIGH
;    	CLRF CMD_4_B1			; b1
;    	CLRF CMD_6_B2			; b2
;    	MOVLW 0x01
;    	MOVWF CMD_8_S1			; s1
;    	MOVLW 0xFF			; CMD
;    	GOTO WRITE_CMD			; IN_L is stored in W
	



;
;---- Main Loop ---------------------------------------------
;

MAIN_LOOP

  	CALL SYNC_QUEUE			; Sync queue
	CALL UNLOCK			; unlock the drive before we upload the data

	movlw LOW TABLE+1 		; get low 8 bits of TABLE address
	MOVWF OFFSET_LO

	CLRF CMD_3_OFSLO		; Start writing at offset 408000 (LSB=0x00)
	MOVLW 0x80
	MOVWF CMD_2_OFSHI		; Store MSB
	

SEND_BLOCK
	movf OFFSET_LO,W		; load offset in w reg
	CALL TABLE			; get byte from table

    	MOVWF CMD_4_B1			; poke_byte( 0x408000+offset, TMP ) 			
    	MOVLW 0x40			
    	CALL POKE_BYTE			; upload byte to drive, 

	INCF CMD_3_OFSLO,F		
	btfsc STATUS,Z 			; page crossed?
	INCF CMD_2_OFSHI,F		

	INCF OFFSET_LO,F		; point to next table byte
	btfsc STATUS,Z 			; page crossed?
	incf PCLATH,F			; yes, increment high address (we use PCLATH)
	btfss PCLATH,2			; end of memory reached? 0x400?
	GOTO SEND_BLOCK
	


SEND_REGION
	movlw REGION			;
    	MOVWF CMD_4_B1			; poke_byte( 0x008100, Region ) 			
	CLRF CMD_3_OFSLO
    	MOVLW 0x81
	MOVWF CMD_2_OFSHI
    	MOVLW 0x00
    	CALL POKE_BYTE			; Send byte



PATCH_MAINLOOP
	
	CALL UNLOCK			; (re)unlock drive

	clrf CMD_4_B1			; b1
	clrf CMD_6_B2			; b2
	clrf CMD_5_OFSHIGH		; offset HIGH
	movlw 0x84			; STACKRET_L
	movwf CMD_3_OFSLO		; ofslo
	movlw 0x8F			; STACKRET_H
	movwf CMD_2_OFSHI		; ofshi
	movlw 0x02
	movwf CMD_8_S1			; s1
	movlw 0xFF			; cmd read
	CALL WRITE_CMD

	MOVLW ORGRET_L			; d2a value
	XORWF IN_L,W
	BTFSS STATUS,Z			; Check ORGRET_L
	GOTO CHECK_DRIVE		
	MOVLW ORGRET_H			; d2a value
	XORWF IN_H,F			; Check ORGRET_H
	BTFSS STATUS,Z
	GOTO CHECK_DRIVE		

	BSF CMD_6_B2,7			; set bit 7, = movlw 0x80
					; B1 is still 0x00
	movlw 0xFE			; cmd write
	CALL WRITE_CMD			; Write 0x8000

	decf CMD_8_S1,F			; s1=1
	BSF CMD_4_B1,6			; set bit 6, = movlw 0x40
    	CLRF CMD_6_B2			; clear B2
	BSF CMD_3_OFSLO,1		; set bit 1, 0x84->0x86 (so add 2)
	movlw 0xFE			; cmd write
	CALL WRITE_CMD			; Modify MAINLOOP

	

CHECK_DRIVE
	CALL SYNC_QUEUE			; Sync queue
	GOTO PATCH_MAINLOOP



	org 0x3FE - 0x344		; lenght of data in bytes= 836=0x344
					; OSCCAL value is not overwritten!
TABLE
	movwf PCL

	DT 0xFD,0x05,0x00,0xF4,0xE0,0xD3,0x54,0xC8,0xF4,0xE1,0xF0,0x02,0x00,0xA0,0xF4,0x44
	DT 0x44,0x83,0x40,0xF4,0xC0,0x76,0x85,0x00,0xF7,0x48,0x18,0x10,0xE8,0x0C,0xF7,0x48
	DT 0x18,0x08,0xE8,0x06,0xF7,0x48,0x0C,0x20,0xE9,0x5D,0xF8,0x28,0x88,0xF4,0x40,0x76
	DT 0x85,0x00,0x80,0x04,0xF4,0x44,0x98,0x85,0x00,0xF4,0x74,0x17,0x88,0x40,0xF5,0x30
	DT 0xFF,0xF9,0x00,0x01,0xF3,0x44,0x31,0xF3,0x14,0x82,0x8B,0x9F,0xF2,0x9F,0xF5,0x30
	DT 0xFE,0xA5,0x81,0xA0,0xF3,0x12,0xF3,0x17,0xF4,0x43,0x84,0x85,0x00,0xF4,0x42,0x82
	DT 0x85,0x00,0xF4,0x43,0x7A,0x85,0x00,0xF4,0x42,0x78,0x85,0x00,0xF4,0x43,0x88,0x85
	DT 0x00,0xF4,0x42,0x86,0x85,0x00,0xF4,0x43,0x7E,0x85,0x00,0xF4,0x42,0x7C,0x85,0x00
	DT 0x80,0x01,0xF4,0x44,0x44,0x83,0x40,0xF4,0x74,0x98,0x80,0x40,0xF4,0x75,0xE2,0x8B
	DT 0x00,0x54,0x00,0xF4,0xE0,0x76,0x02,0x00,0xFD,0x62,0x02,0xD3,0xFC,0xF4,0x76,0x08
	DT 0x83,0x00,0xEA,0x6E,0xF4,0xC9,0x44,0x83,0x40,0x84,0xBC,0xD8,0x01,0xE9,0x10,0xF8
	DT 0x38,0x88,0xF4,0x40,0x76,0x85,0x00,0x84,0xD4,0x01,0xF4,0x44,0x44,0x83,0x40,0xF4
	DT 0xC9,0x44,0x83,0x40,0x84,0xBC,0xD8,0x02,0xE9,0x1B,0xF4,0xC8,0x06,0xBA,0x40,0xF7
	DT 0x48,0xF3,0x00,0xE7,0x10,0xF8,0x01,0xBD,0xF4,0x40,0x7A,0xBD,0x40,0x84,0xD4,0x01
	DT 0xF4,0x44,0x44,0x83,0x40,0xF4,0xC0,0x36,0x83,0x00,0xD8,0x00,0xE8,0x0C,0xF4,0xC0
	DT 0xB8,0x85,0x00,0xD8,0x00,0xE9,0x03,0xFC,0xBA,0x01,0xA0,0xF4,0x40,0x34,0x83,0x00
	DT 0xF4,0x74,0x34,0x83,0x00,0x80,0x01,0x0C,0xF4,0x71,0xFF,0xFF,0x00,0xF4,0xE1,0x4F
	DT 0xCE,0xC8,0xF4,0xC2,0x00,0x81,0x00,0xF5,0x06,0x04,0xE8,0x03,0xFC,0xA2,0x00,0x38
	DT 0xF7,0x48,0xA8,0x00,0xE8,0x03,0xFC,0x98,0x00,0xF5,0x38,0x04,0xD8,0x00,0xE8,0x03
	DT 0xFC,0x8E,0x00,0xF5,0x38,0x05,0xD8,0x01,0xE9,0x55,0xF5,0x38,0x06,0xD8,0x38,0xE9
	DT 0x4E,0xF5,0x38,0x07,0xD8,0x00,0xE9,0x47,0xF4,0x75,0x6C,0x00,0x40,0xF4,0x74,0xC0
	DT 0xD3,0x21,0x54,0x00,0xF4,0x74,0x0F,0x00,0x43,0x30,0xF5,0x02,0x03,0xF3,0x98,0xE8
	DT 0x2A,0xF4,0xC8,0x00,0x81,0x00,0xF5,0x00,0x03,0x10,0xF4,0x74,0x1C,0x00,0x43,0xAF
	DT 0x8D,0x88,0x90,0xF2,0x85,0x90,0xF2,0x85,0x98,0xF2,0x8D,0xFD,0x9D,0x01,0x95,0xF4
	DT 0x61,0x26,0x83,0x40,0x80,0x0A,0xF4,0xE1,0x7B,0xBD,0xC7,0xF2,0x50,0x54,0x00,0xF4
	DT 0x74,0x0D,0x83,0x00,0x30,0xD8,0x00,0xE9,0x28,0xF5,0x30,0x01,0xD8,0x01,0xE9,0x21
	DT 0xF5,0x30,0x02,0xD8,0x10,0xE9,0x1A,0xF4,0x75,0x6C,0x00,0x40,0xF4,0x74,0x60,0xF6
	DT 0x20,0x54,0x00,0xF4,0xC8,0x00,0x81,0x00,0xF4,0x44,0x07,0x00,0x43,0xF2,0x50,0x54
	DT 0x00,0x3A,0x88,0xBC,0xF7,0x48,0xE9,0x00,0xE9,0x0C,0xF5,0x38,0x03,0xF7,0x40,0x00
	DT 0xA5,0xF4,0x40,0x00,0x81,0x00,0xF4,0xC0,0x34,0x83,0x00,0xF7,0x00,0x32,0x05,0xD8
	DT 0x20,0xE8,0x08,0xF4,0xE1,0x09,0xD0,0xC7,0xFC,0xB9,0xFE,0xF4,0xC8,0x69,0x83,0x00
	DT 0xD8,0x00,0xE8,0x0B,0xF4,0xC0,0xB8,0x85,0x00,0xD4,0xFD,0xD8,0x01,0xE7,0x0E,0xA0
	DT 0xF4,0x44,0x69,0x83,0x00,0xF4,0xE1,0xE7,0xCF,0xC7,0xFC,0x97,0xFE,0xF4,0xC8,0x0F
	DT 0x03,0x40,0xF5,0x00,0x10,0xE8,0x14,0xF8,0x00,0x08,0xF4,0x40,0x30,0x83,0x00,0x80
	DT 0x04,0xF4,0x40,0x32,0x83,0x00,0xF4,0xE1,0xE8,0xBB,0xC7,0xF4,0xE1,0xD3,0xBB,0xC7
	DT 0xF4,0xC8,0x68,0x83,0x00,0xF7,0x00,0xFE,0xFF,0xF4,0x44,0x68,0x83,0x00,0xF4,0xC8
	DT 0x46,0x83,0x00,0xD8,0x00,0xE8,0x08,0xD8,0x13,0xE8,0x04,0x80,0x01,0xEA,0x01,0xA0
	DT 0xF4,0x40,0xB8,0x85,0x00,0xAF,0xF4,0x47,0x69,0x83,0x00,0x80,0x01,0xF4,0x71,0xDF
	DT 0xFF,0x00,0xF4,0xE1,0x49,0xD0,0xC8,0xF4,0xC8,0x8C,0x83,0x00,0xD8,0x00,0xE8,0x0A
	DT 0xF4,0x47,0x8C,0x83,0x00,0xF4,0xE1,0xA4,0xA1,0xC8,0x88,0xBC,0x82,0xF7,0x48,0xA8
	DT 0x00,0xE8,0x0F,0xF7,0x4A,0xD0,0x00,0xE8,0x09,0xF7,0x4A,0xA4,0x00,0xE8,0x03,0xFC
	DT 0x12,0xFE,0xF4,0xE1,0x45,0xB6,0xC7,0xF4,0xC8,0x68,0x83,0x00,0xF5,0x04,0x10,0xE9
	DT 0x03,0xFC,0x00,0xFE,0xF5,0x00,0xEF,0xF4,0x44,0x68,0x83,0x00,0xF4,0xE1,0xBB,0x1B
	DT 0xC8,0xFC,0xF0,0xFD,0xF4,0x40,0x34,0x83,0x00,0xF4,0x74,0x34,0x83,0x00,0x80,0x01
	DT 0x0C,0xF4,0x71,0xFF,0xFF,0x00,0xF4,0xE1,0xF8,0xCB,0xC8,0xF4,0xC0,0x34,0x83,0x00
	DT 0xF5,0x08,0x80,0xF4,0x40,0x34,0x83,0x00,0xF4,0xE1,0x14,0xCF,0xC7,0xFC,0xC4,0xFD
	DT 0xD3,0xFC,0xF5,0x5E,0x00,0x6E,0x08,0x98,0x6E,0x0A,0xF2,0x89,0xF5,0x7E,0x00,0xD3
	DT 0x04,0xFE,0xD3,0xFC,0x0C,0x4D,0x02,0xF5,0x7E,0x00,0xD3,0x04,0xFE,0x7C,0x00,0xD3
	DT 0xF0,0xF5,0x5E,0x04,0xF5,0x5F,0x08,0x5D,0x0C,0x5E,0x10,0x5C,0x00,0xFE,0xF5,0x7E
	DT 0x00,0xF5,0x7F,0x04,0x7D,0x08,0x7E,0x0C,0xD3,0x10,0xFE,0xD3,0xFC,0x0C,0x4D,0x02
	DT 0xF5,0x7D,0x00,0xD3,0x04,0xFE,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	DT 0x10,0x00,0x00,0x00,0x10,0xE0,0x04,0x00,0x00,0x00,0x00,0x80,0x80,0x06,0x03,0x03
	DT 0x04,0x03,0x07,0x00

    End


