/*************************************************************
* archdep.c Code that change depending on the microcontroller
* and implimentation
* Chiip (ATmega8L8) Flavor
* Copyright YOLD 3173 OpenWii all rights reversed.
**************************************************************/

/*Include common files*/
#include "../common/common.h"

/* Handle the timer interrupt */
ISR(TIMER0_OVF_vect) {
	msTimerInt(); /*Handle the ms timer (for led flashing)*/
}

/* setup the timer */
inline void SetupTimer()
{
	TIMSK0 |= _BV(TOIE0); /*Set timer interrupt mask*/
	TCCR0B=_BV(CS00);	/*setup timer, start it running div/1 */
}

/* set serial port up */
inline void SetupSerial(void)
{
	// Initialize pins to inputs (high impedance) 
	// on avr this is default reset state so not absolutely necessary
	UBRR0=USART_UBBR_VALUE; /* Here we setup our rs-232 type serial*/
	UBRR0=30;
	UCSR0B=_BV(TXEN0);
}

/* setup data ports*/
inline void portInit() {
       DDRC|= LEDPIN;         /* enable PD5 as output */
}

/* do anything specefic to this micro */
inline void machInit() {
}

/* Turn on the interrupts */
inline void intInit() {
	sei();	/*Global Interrupt Enable*/
}

/* wait approx 1 us */
inline void waitus(uint16_t us)
{
	int x;
	for(x=0;x<(us * 5);x++)
	{
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
	}
}
