/*************************************************************
* archdep.h Things that change depending on the archetecture
* Chiip (ATmega8L8) Flavor - eris
* Copyright YOLD 3173 OpenWii all rights reversed.
**************************************************************/

#ifndef ARCHDEP_H
#define ARCHDEP_H

/*Other files to include for this micro*/
#include <avr/io.h>
#include <avr/sfr_defs.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <inttypes.h>

#define PIN_CLK (_BV(PC0))	//PORT MASK FOR CLK PIN
#define PIN_OUT (_BV(PC1))	//PORT MASK FOR OUTPUT PIN
#define PIN_IN	(_BV(PC2))	//PORT MASK FOR INPUT PIN

/*macros to change the output pin states*/
#define OUTHIZ DDRC &= ~PIN_OUT // Output HiZi
#define OUTLOW DDRC |= PIN_OUT	// Output Low
#define CLKHIZ DDRC &= ~PIN_CLK // clock HiZ
#define CLKLOW DDRC |= PIN_CLK //Drive clock low

/*Macro to read input pin as 0 or 1*/
#define GETIN (((PINC & PIN_IN) >> 2) & 0x1) // read input

/*Macros for LED*/
#define LEDPIN (_BV(PC3))
#define LEDON	PORTC&=~LEDPIN
#define LEDOFF	PORTC|=LEDPIN
#define LEDTOG  PORTC^=LEDPIN

/*Define the clock feq for avr*/
#define F_CPU 8000000	/*Frequency of cpu*/
#define USART_BAUD 9600 /*setup the uart just in case*/
#define USART_UBBR_VALUE ((F_CPU/(USART_BAUD<<4))-1)

/*Stuff used by the timer which isnt really necessary but makes a nice flashing led*/
#define TIMERVAL 1000
#define TIMER0DIV (((F_CPU/256)/TIMERVAL)-1)

#endif
